using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Proxies;
using System.Runtime.Remoting.Channels;

namespace Helpers 
{

	public class RemotingIDHelper
	{
		/// <summary>
		/// gets the url for the object
		/// </summary>
		/// <param name="obj">the MarshalByRefObject to get for</param>
		/// <returns>the url as string</returns>
		public static String GetURLForObject(MarshalByRefObject obj)
		{
			try 
			{
				// trying for CAOs
				ObjRef o = RemotingServices.GetObjRefForProxy(obj);
				if (o!=null) 
				{
					foreach (object data in o.ChannelInfo.ChannelData) 
					{
						ChannelDataStore ds = data as ChannelDataStore;
						if (ds != null) 
						{
							return ds.ChannelUris[0] + o.URI;
						}
					}
				} 
				else 
				{
					// either SAO or not remote!
					String URL = RemotingServices.GetObjectUri(obj);
					return URL;
				}
				return null;
			}
			catch (Exception e) 
			{
				Console.WriteLine("Could not get URL", e);
				return null;
			}
		}
	}
}