using System;
using System.Collections;


namespace Interfaces
{
	/// <summary>
	/// presents an Interface for a Tuple
	/// </summary>
	/// 

	public interface ITuple 
	{
		/// <summary>
		/// Adds a Tuple to current tuple
		/// </summary>
		/// <param name="t">
		/// the Tuple to add
		/// </param>
		void add(ITuple t);
		/// <summary>
		/// Adds an element to current tuple
		/// </summary>
		/// <param name="obj">
		/// the object to add
		/// </param>
		void add(Object obj);
		/// <summary>
		/// Adds a XMLField to current tuple
		/// </summary>
		/// <param name="f">
		/// the IField to add
		/// </param>
		void add(IField f);
		/// <summary>
		/// an enumerator of all elements that are contained
		/// </summary>
		/// <returns>
		/// returns an enumerator of all elements that are contained
		/// </returns>
		IEnumerator getList();
		/// <summary>
		/// gets the TupleID
		/// </summary>
		/// <returns>
		/// returns the tuple's id
		/// </returns>
		int getTupleID();
		/// <summary>
		/// the String representation of the Tuple
		/// </summary>
		/// <returns>
		/// returns the String representation of the Tuple
		/// </returns>
		string ToString();
	}
}
