using System;

namespace Interfaces
{
	/// <summary>
	/// the TupleBucket contains the Tuples
	/// </summary>
	public interface ITupleBucket
	{
			/// <summary>
			/// adds a Tuple to the TupleBucket
			/// </summary>
			/// <param name="t">
			/// the Tuple to add
			/// </param>
			void add(ITuple t);
			/// <summary>
			/// removes a Tuple from the TupleBucket
			/// </summary>
			/// <param name="t_id">
			/// removes the Tuple with these TupleID from the TupleBucket
			/// </param>
			/// <returns>
			/// returns the removed Tuple
			/// </returns>
			ITuple remove(int t_id);
			/// <summary>
			/// removes the Tuple from the TupleBucket
			/// </summary>
			/// <param name="t">
			/// removes these Tuple t from the TupleBucket
			/// </param>
			/// <returns>
			/// returns the removed Tuple
			/// </returns>
			ITuple remove(ITuple t);
			/// <summary>
			/// Name of the TupleBucket
			/// </summary>
			/// <param name="bucketname">
			/// the name of the TupleBucket
			/// </param>
			/// <returns>
			/// returns the name of the TupleBucket
			/// </returns>
			string Name{get;set;}
	}
}
