using System;
using Interfaces;

namespace MatchingRelations
{
	/// <summary>
	/// Compares two integers "<"
	/// </summary>
	[Serializable]
	public class Int32Smaller :  IMatchable
	{
		/// <summary>
		/// the integer value to compare to
		/// </summary>
		int i = 0;
		
		/// <summary>
		/// takes the integer to compare to
		/// </summary>
		/// <param name="toCompare"></param>
		public Int32Smaller(int toCompare)
		{
			i = toCompare;
		}

		/// <summary>
		/// compare passed integer to the given integer
		/// </summary>
		/// <param name="fst">passed integer</param>
		/// <returns>if passed integer is smaller than given integer return true, else false</returns>
		public bool matches(Object fst)
		{
			if(!(fst is int)) return false;
			try 
			{
				return ( (int) fst) < i ;
			} 
			catch(InvalidCastException castex) 
			{
				throw new Exception(castex.Message);
				
			}
		}
	}
}
