using System;
using System.Text;
using Interfaces;

namespace MatchingRelations
{
	/// <summary>
	/// represents a type matching , i.e. a match on the types of Fields but not their values.
	/// </summary>
	[Serializable]
	public class TypeMatch :  IMatchable
	{
		string type = "";
		/// <summary>
		/// stores a Type in the form of package.class 
		/// </summary>
		/// <param name="type">the type in form of package.class</param>
		public TypeMatch(string type)
		{
			this.type = type;
			
		}
		/// <summary>
		/// matches the type of this object and the object o
		/// </summary>
		/// <param name="o">the object to check</param>
		/// <returns>true, if the type matches, false otherwise</returns>
		public bool matches(Object o)
		{
			System.Type t =o.GetType();
			bool match = t.ToString().Equals(type);
			return match;
		}
	}
}