using System;
using System.Xml;
using System.Xml.XPath;
using System.Runtime.Remoting;
using System.Collections;
using Interfaces;
using Helpers;
using System.IO;
//using log4net;
//using log4net.Config;

namespace XMLTupleSpaceShared
{
	///<summary>
	///Class contains static methods to work on XML tuples only
	///</summary>
	public class XMLTupleHandler : MarshalByRefObject
	{
//		private static readonly ILog logger = LogManager.GetLogger(typeof(XMLTupleHandler));
//		private static FileInfo fnfo = new FileInfo("..\\logconfig.xml");
	
		//public XMLTupleHandler()
//		{
//			DOMConfigurator.Configure(fnfo);
//		}

		///<summary>
		///Method adds a tuple to a xml document (empty or not...)
		///</summary>
		///<return>
		///returns modified XmlDocument object
		///</return>
		///<param name="t">
		///Tuple to add
		///</param>
		///<param name="xmldoc">
		///XmlDoc to add tuple to 
		///</param>
		public static XmlNode addToDocument(ExtendedXmlDocument xmldoc, ITuple t) 
		{	
			XmlNode newNode = XMLTupleHelper.convertToXML(xmldoc, t);			
			return newNode;
		}

	
		/// <summary>
		/// find tuples in the bucket with the same tuplecount - and fieldcount- values
		/// </summary>
		/// <param name="xmldoc">the Xmldoc to find for</param>
		/// <param name="t">the searching tuple</param>
		/// <returns>an XmlNodeList with matching XmlNodes</returns>
		public static XmlNodeList findTuples(ExtendedXmlDocument xmldoc, ITuple t)
		{
			int tuplecount = Int32.Parse(((XmlElement)((XMLTuple) t).getXmlDocument().DocumentElement).GetAttribute("tuplecount"));
			int fieldcount = Int32.Parse(((XmlElement)((XMLTuple) t).getXmlDocument().DocumentElement).GetAttribute("fieldcount"));
			string expr = "./TupleSpace/Tuple[@tuplecount=" + tuplecount + " and @fieldcount=" +fieldcount+"]";
			XmlNodeList list = xmldoc.SelectNodes(expr);
			return list;
		}
	}
}